/*
chains.c Version 0.1.0  Hash print database
in physical sequence
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: chains filename */

#include <bthash.h>
#include <math.h>

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage %s filename\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int opnerr;
   int rslt;
   int count;
   int smlen;
   int smlensq;
   int freelen;
   double avg;
   double stdev;
   double variance;
   hashfmt *hshhdr;
   char dbname[256];
   if (argc != 2) putstx(*argv);
   strcpy(dbname,*(argv+1));

   hshhdr = (hashfmt *) hopen(dbname,READ,TSTLOCK,&opnerr);
   if (hshhdr == NULL)
      {
      fprintf(stderr,"chains: hopen "
	 "error %d\n", opnerr);
      exit(1);
      } /* open err */
   /* process starts here */

   hchain(hshhdr,&count,&smlen,&smlensq,&freelen);
   if (hshhdr->reason)
      {
      fprintf(stderr,"chains: hchain "
	 "error reason %d\n",
	 hshhdr->reason);
      rslt = hdbck(hshhdr);
      if (rslt || hshhdr->reason)
         {
         fprintf(stderr,"chains: hchain "
	    "error %d reason %d\n",
	    rslt, hshhdr->reason);
         } /* if check err */
      exit(1);
      } /* if hchain err */
   printf("chains: totrcds %d count %d "
      "sum %d sumsq %d free %d\n",
      hshhdr->totrcds, count,
      smlen, smlensq, freelen);
   if (count)
      {
      avg = (double) smlen / (double) count;
      variance = (((double) count * (double) smlensq)
         - ((double) smlen * (double) smlen))
         / ((double) count * ((double) count - 1.0));
      stdev = sqrt(variance);
      printf("chains: average %.1f stdev %.1f stdev3 %.1f\n",
         avg, stdev, stdev * 3.0);
      } /* if not divide by zero */
   else
      {
      printf("chains: no statistics\n");
      } /* if count is zero */

   /**********************************************************/
   hclose(hshhdr);
   return(0);
   } /* main */
